import React, { useState, useEffect } from 'react';
import './App.css';
import Header from './components/Header';
import Table from './components/Table';

const App = () => { 
  const [user, setUser] = useState({})
  const [loaded, setLoaded] = useState(false);
  const [child, setChild] = useState(<h3>App is loading</h3>)

  useEffect(() => {
    const script = document.createElement('script');
    script.src = 'https://cdn.freshdev.io/assets/app-client@2.js';
    script.addEventListener('load', () => {
      console.log('script loaded')
      setLoaded(true)
    });
    script.defer = true;
    document.head.appendChild(script);
  }, []);

  useEffect( () => {
    if (!loaded) return
    console.log('Initializing app...')
    // app.initialized().then((client) => {
    //   console.log('App initialized...')
    //   setChild((<Table client={client} />))
    // })
    const initalizeApp = async () => {
      const client = await app.initialized()
      console.log('App initialized...', client)

      const iparams = await client.iparams.get('permissions')
      const allowedUsers = iparams.permissions.replaceAll(' ', '').split(',')
      console.log(allowedUsers)
      const {loggedInUser: {contact: {name, email}}} = await client.data.get("loggedInUser")
      console.log("Found user:", email)

      if (allowedUsers.includes(email)) {
        setChild((<Table client={client} />))
        setUser({name, email})
      }
      else setChild(<h1>Access denied.</h1>)
    }
    
    try {
      initalizeApp()

    } catch (e) {
      console.error(e)
    }

  }, [loaded])

  return (
    <div>
      <Header user={user}/>
      {child}
    </div>
  )
}

export default App;
