import React from "react";

function AgentActivityBar({agent, setErrorMsg}){
    const now = Date.now()
    const today = new Date(now)
    console.log(today)
    const year = today.getFullYear()
    const month = today.getMonth()
    const day = today.getDate()
    const startOfDay = today.setHours(0,0,0)
    
    const agentActivityBar = []

    console.log(agent.history)
    const millisecondsInADay = 86400000

    // ShiftStart Block must be created for the first activity of the day. It is the difference of the current activity.timestamp and 00 hours.
    function createShiftStartBlock(activity) {
        const width = (activity.timestamp - startOfDay) / millisecondsInADay * 100 
        agentActivityBar.push(<div style={{width: `${width}%`}} className={`activity-block ${activity.status === 'AVAILABLE' ? 'inactive' : 'active'}`}></div>) 
    }

    // Past activity blocks must be created for all activities other than the first activity of the day. It is the difference between the currentIndex activity.timestamp and the previousIndex activity.timestamp.
    function createPastActivityBlock(activity, previousIndex) {
        const width = (activity.timestamp - previousIndex.timestamp) / millisecondsInADay * 100 
        agentActivityBar.push(<div style={{width: `${width}%`}} className={`activity-block ${previousIndex.status === 'AVAILABLE' ? 'active' : 'inactive'}`}></div>) 
    }

    // Current activity blocks must be created for the last activity of the day. It is the difference between the current time Date.now() and the currentIndex activity.timestamp.
    function createCurrentActivityBlock(activity){
        const width = (now - activity.timestamp) / millisecondsInADay * 100
        agentActivityBar.push(<div style={{width: `${width}%`}} className={`activity-block ${activity.status === 'AVAILABLE' ? 'active' : 'inactive'}`}></div>)
    }
    

    try {
        
        const agentActivity = agent.history[year][month][day]['activity']

        console.log(agentActivity)
    
        console.log(agent.firstName, agentActivity)
        agentActivity.forEach((activity, index, array) => {
            const previousIndex = array[index - 1];
            console.log("prev index", previousIndex, index)
            
            if (index === 0) createShiftStartBlock(activity); 
            
            else if (index >= 1) createPastActivityBlock(activity, previousIndex)
    
            if (index === array.length - 1) createCurrentActivityBlock(activity)
        })
    } catch (e) {
        console.error(e)
        setErrorMsg(error.response)
    }

    return (
        <div className={`activity-bar ${agent.firstName.toLowerCase()}-${agent.lastName.toLowerCase()}`}>
            {agentActivityBar}
        </div>
    )
}

export default AgentActivityBar